#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <ctype.h>
#include <unistd.h>

#ifndef BASEPORT 
#  define  BASEPORT 0x378
#endif
#define  PORTSIZE 8


#define LED_RA_SHIFT      0
#define LED_RA_MASK       0x0f
#define LED_RED_MASK      0x10
#define LED_GREEN_MASK    0x20
#define LED_NENABLE_MASK  0x40   /* 0  1Ǿ */
#define LED_LATCH_MASK    0x80
#define LED_STB_MASK      0x01

typedef struct _ledCont {
  int portAdr;
  int lineDelay;
  struct _ledBuf *buf;
} LedCont;


typedef struct _ledBuf {
  int width;
  int height;
  int redMask;
  int greenMask;
  unsigned char *data;
} LedBuf;


/* ץȥ */

void outLedDrive(LedCont *cont,LedBuf *buf);
int main(int argc,char *argv[]);
void ledParseCommandFile(LedCont *cont,FILE *ifp);
void ledCmdClear(LedCont *cont,char *line);
void ledCmdLight(LedCont *cont,char *line);
void ledCmdDraw(LedCont *cont,char *line);
void ledCmdShift(LedCont *cont,char *line);
void ledPixelSet(LedBuf *buf,int x,int y,int color);
LedCont *ledContNew();
void ledErrorExit(char *fmt, ...);
void *ledMalloc(size_t size);
void ledFree(void *block);
